import java.awt.*;
import java.applet.*;
import java.awt.event.*;

/**
    A snake game applet -- the main class
    @author Vincent Wing Hei, Ho
    @version 02.05.2000
*/

public class A7 extends Applet implements ActionListener, KeyListener {
    /** Time interval between update of snake */
    private Ticker t;
    /** Reset button */
    private Button reset;
    /** Create the snake */
    private Snake snake1;
    /** Determine if needed to clear screen in order to reduce flicker */
    private boolean clearScreen = false;

	 public void init() {
        reset = new Button("Reset");        // setup the reset button
        reset.addActionListener(this);
        add(reset);

        snake1 = new Snake(200, 200);

        addKeyListener(this);
        requestFocus();
        
        t = new Ticker (100);
     	t.addActionListener(this);	
	}

	/**
	Draw the snake and
	see if clear screen is needed
	*/
   public void paint(Graphics g) {
       snake1.draw(g);
       if (clearScreen) {
           g.setColor(Color.white); 
           g.fillRect(0,0,400,400);
           clearScreen = false;
        }
    }

	/**
	Deal with ActionEvents
	*/    
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == reset) {
            snake1 = new Snake(200,200);
            clearScreen = true;
            requestFocus();
        }

        if ((e.getSource() == t) && (!snake1.isDead())) {
            snake1.move();
            repaint();
        }
    }

    /**
    Take user inputs, calling appropriate methods
    */
 	 public void keyPressed(KeyEvent e) {
	     if (e.getKeyChar() == 'w') 
            snake1.faceUp();
	     else if (e.getKeyChar() == 's') 
            snake1.faceDown();
	     else if (e.getKeyChar() == 'a') 
            snake1.faceLeft();
	     else if (e.getKeyChar() == 'd') 
            snake1.faceRight();
	 }
	
	/**
	To give smoother action as back is not redrawn
	@param g the Graphics object
	*/
	public void update(Graphics g) {
		paint(g);
	}
	
	// Unused methods, but needed to compile
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}
}